/**
 * Application manipulant des figures

 * @author Matthias Colin
 * @version 1.0 (5/03/2009)
 */

public class DessinerFigures {

	/**
	 * l'application manipule 3 points A, B et D, un triangle T et un cercle C :
	 *	- constructions des différentes figures
	 *	- affichage
	 *	- translation et affichage
	 *	- calculs de surface et de périmètre
	 */
	public static void main(String[] args) {
		Point pointA, pointB, pointD, pointE, pointO;
		Cercle cercleC;
		Triangle triangleT;
		Polygone pentagone;
		
		pointA = new Point("A", 3, 5);
		System.out.println(pointA);
		pointA.translater(4, -3);
		System.out.println("translation de (4,-3) -> " + pointA);
		pointB = new Point("B", 3, 5);
		System.out.println("distance [" + pointA + "-" + pointB + "] = " + pointA.distance(pointB));  
		
		cercleC = new Cercle("C", pointB, 10);
		System.out.println(cercleC + " : perimetre = " + cercleC.perimetre() 
			+ " / surface = " + cercleC.surface());
		cercleC.translater(-1,-1);
		System.out.println("translation de C de (-1,-1) : " + cercleC + " et " + pointB);
		pointB.translater(-1, -1);
		System.out.println("translation de B de (-1,-1) : " + cercleC + " et " + pointB);
		
		pointD = new Point("D", 10, 8);
		triangleT = new Triangle("T", pointA, pointB, pointD);
		System.out.println(triangleT);
		triangleT.translater(-1,-1);
		System.out.println("translation de T de (-1,-1) : " + triangleT);
		
		pointE = new Point("E", 5, 13);
		pointO = new Point("O", 0, 0);
		
		pentagone = new Polygone(pointA, pointB, pointD, pointE, pointO);
		System.out.println(pentagone + " / perimètre : " + pentagone.perimetre());
		pentagone.translater(5, -7);
		System.out.println(pentagone + " / perimètre : " + pentagone.perimetre());
	}
}
