public class Polygone {

	// les sommets du Polygone
	private Point[] sommets;

	/**
	 * constructeur de la classe Polygone
	 * @param sommets : les points formant les sommets du Polygone
	 * NB : le type Point... est assimil au type Point[] dans son
	 * traitement
	 */
	public Polygone(Point... sommets) {
		this.sommets = sommets;
	}
	
	// accesseurs [ dpendants de l'implmentation interne du polygone ]
	
	/**
	 * obtenir le nombre de sommets du Polygone
	 * @return : le nombre de sommets
	 */
	public int getNombreSommets() {
		return sommets.length;
	}

	/**
	 * obtenir un sommet du Polygone  partir de son index
	 * les sommets sont numrots de 1  n
	 * @param index : numro du sommet  renvoyer
	 */
	public Point getSommet(int index) {
		if ((index > 0) || (index <= sommets.length)) {
			return sommets[index - 1];
		} else {
			return null;
		}
	}

	// autres mthodes [ indpendantes de l'implmentation interne du polygone ]
	
	/**
	 * translater la figure
	 * @param deplacementHorizontal : partie horizontale du vecteur de dplacement
	 * @param deplacementVertical : partie verticale du vecteur de dplacement
	 */
	 public void translater(
			int deplacementHorizontal,
			int deplacementVertical) 
	{
		// pour dplacer le polygone, on dplace tous ses sommets
		for (Point sommet : sommets) {
			sommet.translater(deplacementHorizontal, deplacementVertical);
		}
	}

	/**
	 * obtenir le primtre de la figure
	 * @return le primtre
	 */
	public float perimetre() {
		float perimetreCalcule; // primtre calcul
		perimetreCalcule = 0;
		// on additionne les distances entre les sommets i  i+1 pour
		// les n-1 premiers sommets
		for (int i = 1; i < this.getNombreSommets(); i++) {
			perimetreCalcule += this.getSommet(i).distance(this.getSommet(i+1));
		}
		// on ajoute la distance du dernier sommet au 1er
		perimetreCalcule += this.getSommet(this.getNombreSommets()).distance(
				this.getSommet(1));
		return perimetreCalcule;
	}
	
	/**
	 * reprsentation de la figure en chane de caractres
 	 * Format : Poly|point1|...|pointn|
 	 */ 
	public String toString() {
		String polygoneTexte;
		polygoneTexte = "Poly|";
		for (Point sommet : sommets) {
			polygoneTexte += sommet + "|";
		}
		return polygoneTexte;
	}
	
}